package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLFixedBox_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLFixedBox extends JNIObject  {
	
	/* @generated */
	protected ISLFixedBox(long ptr) {
		/*** PROTECTED REGION ID(ISLFixedBox_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLFixedBox build(long ptr) {
		return new ISLFixedBox(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLFixedBox_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_fixed_box_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_fixed_box_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_fixed_box_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_fixed_box_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_fixed_box_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_copy 
	 * 
	 * @generated
	**/
	public ISLFixedBox copy() {
		/*** PROTECTED REGION ID(isl_fixed_box_copy) DISABLED START ***/
		ISLFixedBox res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLFixedBox.build(ISLNative.isl_fixed_box_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_fixed_box_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_fixed_box_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_is_valid 
	 * 
	 * @generated
	**/
	public boolean isValid() {
		/*** PROTECTED REGION ID(isl_fixed_box_is_valid) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_fixed_box_is_valid(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_get_offset 
	 * 
	 * @generated
	**/
	public ISLMultiAff getOffset() {
		/*** PROTECTED REGION ID(isl_fixed_box_get_offset) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiAff.build(ISLNative.isl_fixed_box_get_offset(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_fixed_box_get_size 
	 * 
	 * @generated
	**/
	public ISLMultiVal getSize() {
		/*** PROTECTED REGION ID(isl_fixed_box_get_size) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiVal.build(ISLNative.isl_fixed_box_get_size(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLFixedBox_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
